<html>
<head>
<title>OgreShaderRenderState.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderRenderState.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderRenderState_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderRenderState_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderRenderState_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 <span class="keyword">namespace </span>RTShader {
<a name="l00036"></a>00036 
<a name="l00050"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html">00050</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="comment">// Interface.</span>
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00057"></a>00057     <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>();
<a name="l00058"></a>00058 
<a name="l00060"></a>00060     <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>();
<a name="l00061"></a>00061 
<a name="l00063"></a>00063     <span class="keywordtype">void</span>        reset                       ();
<a name="l00064"></a>00064 
<a name="l00068"></a>00068     <span class="keywordtype">void</span>        addTemplateSubRenderState   (<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073     <span class="keywordtype">void</span>        removeTemplateSubRenderState (<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState);
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a">00076</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>&amp;   <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a" title="Get the list of the template sub render states composing this render state.">getTemplateSubRenderStateList</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSubRenderStateList; }
<a name="l00077"></a>00077 
<a name="l00086"></a>00086     <span class="keywordtype">void</span>            setLightCount           (<span class="keyword">const</span> <span class="keywordtype">int</span> lightCount[3]);
<a name="l00087"></a>00087 
<a name="l00096"></a>00096     <span class="keywordtype">void</span>            getLightCount           (<span class="keywordtype">int</span> lightCount[3]) <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00104"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877">00104</a>     <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877" title="Set the light count auto update state.">setLightCountAutoUpdate</a> (<span class="keywordtype">bool</span> autoUpdate) { mLightCountAutoUpdate = autoUpdate; }
<a name="l00105"></a>00105 
<a name="l00110"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb">00110</a>     <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb" title="Return true if this render state override the light count.">getLightCountAutoUpdate</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLightCountAutoUpdate; }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     <span class="comment">// Attributes.</span>
<a name="l00116"></a>00116 <span class="keyword">protected</span>:
<a name="l00117"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">00117</a>     <a class="code" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>  <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">mSubRenderStateList</a>;            <span class="comment">// The sub render states list.  </span>
<a name="l00118"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a969c088c5e51a22c211c535375d139a8">00118</a>     <span class="keywordtype">int</span>                 mLightCount[3];                 <span class="comment">// The light count per light type definition.</span>
<a name="l00119"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">00119</a>     <span class="keywordtype">bool</span>                <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">mLightCountAutoUpdate</a>;          <span class="comment">// True if light count was explicitly set.</span>
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 <span class="keyword">private</span>:
<a name="l00122"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">00122</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1RTShader_1_1RenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">00123</a>     <span class="keyword">friend</span> <span class="keyword">class </span>FFPRenderStateBuilder;
<a name="l00124"></a>00124 };
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="group__RTShader.html#ga3a45db6ba3ebab9f7a49005934a19213">00127</a> <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderState*&gt;::type</a>              <a class="code" href="group__RTShader.html#ga3a45db6ba3ebab9f7a49005934a19213">RenderStateList</a>;
<a name="l00128"></a><a class="code" href="group__RTShader.html#ga9eabb56de59faf73d0671baef58ba5b0">00128</a> <span class="keyword">typedef</span> RenderStateList::iterator               <a class="code" href="group__RTShader.html#ga9eabb56de59faf73d0671baef58ba5b0">RenderStateIterator</a>;
<a name="l00129"></a><a class="code" href="group__RTShader.html#ga9b53abaeb85c8e817dafe314bf1ef7e8">00129</a> <span class="keyword">typedef</span> RenderStateList::const_iterator         <a class="code" href="group__RTShader.html#ga9b53abaeb85c8e817dafe314bf1ef7e8">RenderStateConstIterator</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00136"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html">00136</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html" title="This is the target render state.">TargetRenderState</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">// Interface.</span>
<a name="l00140"></a>00140 <span class="keyword">public</span>:
<a name="l00141"></a>00141     
<a name="l00143"></a>00143     <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af77db1b842b76ad71dd6a8fc1d2cfbfc" title="Class default constructor.">TargetRenderState</a>();
<a name="l00144"></a>00144 
<a name="l00146"></a>00146     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a72b162894e32d917fdde813f40f381e8" title="Class destructor.">~TargetRenderState</a>();
<a name="l00147"></a>00147 
<a name="l00154"></a>00154     <span class="keywordtype">void</span>        <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a48a0f2bf833e3dd562b68e16bdbcfef8" title="Link this target render state with the given render state.">link</a>                (<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>&amp; other, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* srcPass, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* dstPass);
<a name="l00155"></a>00155 
<a name="l00162"></a>00162     <span class="keywordtype">void</span>    <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ad201f02cccf5fe0db97ae3c103aba73b" title="Update the GPU programs constant parameters before a renderable is rendered.">updateGpuProgramsParams</a> (<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AutoParamDataSource.html" title="This utility class is used to hold the information used to generate the matrices and other informatio...">AutoParamDataSource</a>* source, <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>* pLightList);
<a name="l00163"></a>00163     
<a name="l00164"></a>00164 <span class="comment">// Protected methods</span>
<a name="l00165"></a>00165 <span class="keyword">protected</span>:
<a name="l00166"></a>00166 
<a name="l00168"></a>00168     <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#af0cc11490a2a8d38b00befd3f68209bd" title="Sort the sub render states composing this render state.">sortSubRenderStates</a>     ();
<a name="l00169"></a>00169 
<a name="l00171"></a>00171     <span class="keyword">static</span> <span class="keywordtype">int</span>      <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a9217c8ca6e166e12ae2d2478cf1d6e34" title="Comparison function of the sub render states.">sSubRenderStateCompare</a>  (<span class="keyword">const</span> <span class="keywordtype">void</span> * p0, <span class="keyword">const</span> <span class="keywordtype">void</span> *p1);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     
<a name="l00176"></a>00176     <span class="keywordtype">bool</span>        <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a43689030b303d846f56d1325dbeb4e29" title="Create CPU programs that represent this render state.">createCpuPrograms</a>       ();
<a name="l00177"></a>00177 
<a name="l00180"></a>00180     <a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7b1fa1bf7f80b797042f3dc26043f733" title="Create the program set of this render state.">createProgramSet</a>            ();
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="comment">/* Destroy the program set of this render state. */</span>
<a name="l00183"></a>00183     <span class="keywordtype">void</span>        <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ac70b2331c9f7c36f98ef73e7892d8a25">destroyProgramSet</a>           ();
<a name="l00184"></a>00184 
<a name="l00187"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a78bca39bab68931c862f04b3c6384d4b">00187</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a78bca39bab68931c862f04b3c6384d4b" title="Return the program set of this render state.">getProgramSet</a>               () { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5ae4ed95d719aa2c2a15a2133c1e0f11">mProgramSet</a>; }
<a name="l00188"></a>00188 
<a name="l00192"></a>00192     <span class="keywordtype">void</span>        <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a7a33d4ee212f7e8fb483cb33e36cf0fb" title="Add sub render state to this render state.">addSubRenderStateInstance</a>           (<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState);
<a name="l00193"></a>00193 
<a name="l00197"></a>00197     <span class="keywordtype">void</span>        <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5d7eb06c5a7db62569b4c8757282b9c8" title="Remove sub render state from this render state.">removeSubRenderStateInstance</a>        (<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     
<a name="l00200"></a>00200 <span class="comment">// Attributes.</span>
<a name="l00201"></a>00201 <span class="keyword">protected</span>:
<a name="l00202"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a020129dfa474d4e35d37c0439f556663">00202</a>     <span class="keywordtype">bool</span>                <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a020129dfa474d4e35d37c0439f556663">mSubRenderStateSortValid</a>;       <span class="comment">// Tells if the list of the sub render states is sorted.</span>
<a name="l00203"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5ae4ed95d719aa2c2a15a2133c1e0f11">00203</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>*         <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a5ae4ed95d719aa2c2a15a2133c1e0f11">mProgramSet</a>;                    <span class="comment">// The program set of this RenderState.</span>
<a name="l00204"></a>00204     
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="keyword">private</span>:
<a name="l00207"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">00207</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>;
<a name="l00208"></a><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">00208</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">FFPRenderStateBuilder</a>;
<a name="l00209"></a>00209 };
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="preprocessor">#endif</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
